# eu.astrogd.white-leopard
A Discord bot that checks Discord channel names for banned words and prevents renaming of them

## Commands
### /logchanel [channel?]
Sets the channel where the bot will log if a channel meets the banned word criteria. If channel is omitted, the log channel will be disabled.

### /blocklist
#### /blocklist get
Gets the global and server specific banned word list and returns it

#### /blocklist add [word]
Adds the word to the server specific blocklist

#### /blocklist remove [word]
Removes the word from the server specific blocklist

### /info
Returns general information about the bot and the servers stats

## Environment variables
| Name             | Description                                                                     | Required | Example             |
| :--------------- | :------------------------------------------------------------------------------ | :------: | :------------------ |
| TOKEN            | Discord bot token to log into the API with                                      |   ▶️/🚀    | NzYzMDP3MzE1Mzky... |
| DB_HOST          | Hostname of the database                                                        |    ▶️     | 127.0.0.1:3546      |
| DB_USERNAME      | Username of the database                                                        |    ▶️     | root                |
| DB_PASSWORD      | Password of the database                                                        |    ▶️     | abc123              |
| DB_DATABASE      | Database name                                                                   |    ▶️     | white-leopard       |
| CLIENT_ID        | Client ID of the Discord appication associated with the token                   |    🚀     | 763035392692274     |
| DEPLOY_TOKEN     | Production Discord bot token to log into the API with                           |    🚀     | NzYzMDP3MzE1Mzky... |
| DEPLOY_CLIENT_ID | Production Client ID of the Discord appication associated with the deploy token |    🚀     | 763035392692274     |

### Icon explanation:
- ▶️ = Required in runtime
- 🚀 = Required during CI/CD