import { database, GuildSetting } from "../data";

export async function getGuildSetting(guildID: string): Promise<GuildSetting> {
    let guildSetting = await database.getRepository(GuildSetting).findOne({
        where: {
            id: guildID
        }
    });

    if (!guildSetting) {
        guildSetting = new GuildSetting();
        guildSetting.id = guildID;
        guildSetting.isPremiumUntil = null;
        guildSetting.notificationChannelID = null;
    }

    return guildSetting;
}

export function isPremiumActive(timestamp: Date | null): boolean {
    if (timestamp === null) return false;
    const now = Number(new Date());
    const activeUntil = Number(timestamp);

    return now < activeUntil;
}