import pack from "../../package.json";
import { EmbedBuilder } from "discord.js";
import client from "../client";
import { Color, Emoji } from "./design";

// const _coolColors = [0x054566];

export default function getDefaultEmbed(): EmbedBuilder {
    const embed = new EmbedBuilder();
    embed.setFooter({
        text: `Channel filter V${pack.version} by AstroGD®`,
        iconURL: client.user?.avatarURL() || undefined,
    });
    embed.setTimestamp(new Date());
    embed.setColor(Color.ANONYMOUS_GRAY);

    return embed;
}

export function getSuccessEmbed(): EmbedBuilder {
    const embed = getDefaultEmbed();
    embed.setTitle(`${Emoji.CHAT_APPROVE} Success`);
    embed.setColor(Color.SUCCESSFUL_GREEN);
    return embed;
}

export function getFailedEmbed(): EmbedBuilder {
    const embed = getDefaultEmbed();
    embed.setTitle(`${Emoji.CHAT_DENY} Failed`);
    embed.setColor(Color.STOPSIGN_RED);
    return embed;
}